package main

import (
	"fmt"
	"math/rand"
	"time"
)

type Robot struct {
	x int
	y int
	direzione string
}

type coords struct {
	x int
	y int
}

func costruisci(x int, y int, direzione string) (Robot, bool) {
	switch direzione {
		case "su", "giù", "destra", "sinistra":
			return Robot{x,y,direzione}, true
		default:
			return Robot{}, false
	}
}

func stato(r Robot) {
	fmt.Println(r)
}

func avanza(r *Robot) {
	switch r.direzione {
		case "su":
			r.y--
		case "giù":
			r.y++
		case "destra":
			r.x++
		case "sinistra":
			r.x--
	}
}

func ruota(r *Robot, d bool) {
	if d {
		switch r.direzione {
			case "su":
				r.direzione = "destra"
			case "giù":
				r.direzione = "sinistra"
			case "destra":
				r.direzione = "giù"
			case "sinistra":
				r.direzione = "su"
		}
	} else {
		switch r.direzione {
			case "su":
				r.direzione = "sinistra"
			case "giù":
				r.direzione = "destra"
			case "destra":
				r.direzione = "su"
			case "sinistra":
				r.direzione = "giù"
		}
	}
}

func griglia(r []Robot, xmin, xmax, ymin, ymax int) {
	robots := make(map[coords]Robot)
	
	for _,v := range(r) {
		dt := coords{v.x,v.y}
		robots[dt] = v
	}
	
	for j:=ymin;j<=ymax;j++ {
		for i:=xmin;i<=xmax;i++ {
			if rob, ok := robots[coords{i,j}]; ok { //altrimenti un for su robots per vedere se esiste alle coordinate i,j
				switch rob.direzione {
					case "su":
						fmt.Print("⬆")
					case "giù":
						fmt.Print("⬇")
					case "destra":
						fmt.Print("➡")
					case "sinistra":
						fmt.Print("⬅")
				}
			} else {
				fmt.Print("□")
			}
		}
		fmt.Println()
	}
}

func vista(r []Robot) [][]Robot {
	ret := make([][]Robot,0)
	
	for i:=0; i<len(r)-1; i++ {
		for j:=i+1; j<len(r); j++ {
			if r[i].x == r[j].x {
				if r[i].y > r[j].y {
					if r[i].direzione == "su" && r[j].direzione == "giù" {
						ret = append(ret, []Robot{r[i],r[j]})
					}
				} else {
					if r[j].direzione == "su" && r[i].direzione == "giù" {
						ret = append(ret, []Robot{r[i],r[j]})
					}
				}
			} else if r[i].y == r[j].y {
				if r[i].x > r[j].x {
					if r[i].direzione == "sinistra" && r[j].direzione == "destra" {
						ret = append(ret, []Robot{r[i],r[j]})
					}
				} else {
					if r[j].direzione == "sinistra" && r[i].direzione == "destra" {
						ret = append(ret, []Robot{r[i],r[j]})
					}
				}
			}
		}
	}
	
	return ret
}

func ruotare(r []Robot) {
	rand.Seed(time.Now().UnixNano())
	
	for i := range(r) {
		ruota(&r[i], rand.Intn(2)==1)
	}
}

func main() {

	robots := make(map[coords]Robot)
	
	for {
		var tx,ty int
		var tdir string

		fmt.Println("Inserisci un robot:")
		fmt.Scanf("%d %d %s",&tx, &ty, &tdir)

		tr,tb := costruisci(tx,ty,tdir)

		if !tb {
			fmt.Println("Robot inseriti:")

			for _,v := range(robots) {
				fmt.Println(v)
			}
			return
		}
		
		if _, ok := robots[coords{tx,ty}]; ok {
			fmt.Println("occupato")
			continue
		}
		
		robots[coords{tx,ty}] = tr
	}
}
