package main

import (
	"fmt"
)

type Robot struct {
	x int
	y int
	direzione string
}

func costruisci(x int, y int, direzione string) (Robot, bool) {
	switch direzione {
		case "su", "giù", "destra", "sinistra":
			return Robot{x,y,direzione}, true
		default:
			return Robot{}, false
	}
}

func stato(r Robot) {
	fmt.Println(r)
}

func avanza(r *Robot) {
	switch r.direzione {
		case "su":
			r.y--
		case "giù":
			r.y++
		case "destra":
			r.x++
		case "sinistra":
			r.x--
	}
}

func ruota(r *Robot, d bool) {
	if d {
		switch r.direzione {
			case "su":
				r.direzione = "destra"
			case "giù":
				r.direzione = "sinistra"
			case "destra":
				r.direzione = "giù"
			case "sinistra":
				r.direzione = "su"
		}
	} else {
		switch r.direzione {
			case "su":
				r.direzione = "sinistra"
			case "giù":
				r.direzione = "destra"
			case "destra":
				r.direzione = "su"
			case "sinistra":
				r.direzione = "giù"
		}
	}
}

func griglia(r []Robot, xmin, xmax, ymin, ymax int) {
	
	for j:=ymin;j<=ymax;j++ {
		for i:=xmin;i<=xmax;i++ {

			exist :=false

			for _,v:=range(r) {
				if v.x == i && v.y == j {
					exist = true
					switch v.direzione {
						case "su":
							fmt.Print("⬆")
						case "giù":
							fmt.Print("⬇")
						case "destra":
							fmt.Print("➡")
						case "sinistra":
							fmt.Print("⬅")
					}
				}
			}
			
			if !exist {
				fmt.Print("□")
			}
		}
		fmt.Println()
	}
}

func vista(r []Robot) [][]Robot {
	ret := make([][]Robot,0)
	
	for i:=0; i<len(r)-1; i++ {
		for j:=i+1; j<len(r); j++ {
			switch {
				case
					r[i].x == r[j].x && r[i].y > r[j].y && r[i].direzione == "su" && r[j].direzione == "giù",
					r[i].x == r[j].x && r[i].y < r[j].y && r[j].direzione == "su" && r[i].direzione == "giù",
					r[i].y == r[j].y && r[i].x > r[j].x && r[i].direzione == "sinistra" && r[j].direzione == "destra",
					r[i].y == r[j].y && r[i].x < r[j].x && r[j].direzione == "sinistra" && r[i].direzione == "destra":
						ret = append(ret, []Robot{r[i],r[j]})
			}
		}
	}
	
	return ret
}

func main() {

	robots := make([]Robot,0)
	
	for {
		var tx,ty int
		var tdir string

		fmt.Println("Inserisci un robot:")
		fmt.Scanf("%d %d %s",&tx, &ty, &tdir)

		tr,tb := costruisci(tx,ty,tdir)

		if !tb {
			fmt.Println("Robot inseriti:")

			for _,v := range(robots) {
				fmt.Println(v)
			}
			return
		}
		
		exists := false

		for _,r:=range(robots) {
			if r.x == tx && r.y == ty {
				exists = true
				fmt.Println("occupato")
				break
			}
		}
		
		if !exists {
			robots = append(robots,tr)
		}
	}
}
